from sqlalchemy import Column, Integer, String, VARCHAR, DateTime

from ...data import Base


class EU_SUST_FIN_ISSUER_MASTER(Base):
    __tablename__ = 'EU_SUST_FIN_ISSUER_MASTER'
    __table_args__ = {"schema": "ESG"}
    
    ISSUER_NAME = Column(VARCHAR, primary_key=True)
    ISSUERID = Column(String(80), primary_key=True)
    ISSUER_LEI = Column(String(80))
    COUNTRY_OF_CLASSIFICATION = Column(String(80))
    ISSUER_CNTRY_DOMICILE = Column(String(80))
    GICS_SUB_IND = Column(String(80))
    GICS_SUB_IND_CODE = Column(String(80))
    GICS_IND = Column(String(80))
    GICS_IND_CODE = Column(String(80))
    GICS_SECTOR = Column(String(80))
    GICS_SECTOR_CODE = Column(String(80))
    GICS_IND_GRP = Column(String(80))
    GICS_IND_GRP_CODE = Column(String(80))
    PARENT_ISSUERID = Column(String(80))
    PARENT_ISSUERNAME = Column(String(80))
    PARENT_ULTIMATE_ISSUERID = Column(String(80))
    PARENT_ULTIMATE_ISSUERNAME = Column(String(80))
    ISSUER_TYPE = Column(String(80))
    PUBLICATION_DATE = Column(DateTime)
    AS_OF_DATE = Column(DateTime)
    LAST_MODIFIED_ON = Column(DateTime)
    MARKETCAP_USD = Column(Integer)
    NACE_GROUP_CODE = Column(String(80))
    NACE_GROUP_DESCRIPTION = Column(String(80))
    NACE_SECTION_CODE = Column(String(80))
    NACE_SECTION_DESCRIPTION = Column(String(80))
    NACE_DIVISION_CODE = Column(String(80))
    NACE_DIVISION_DESCRIPTION = Column(String(80))
    NACE_CLASS_CODE = Column(String(80))
    NACE_CLASS_DESCRIPTION = Column(String(80))


class EU_SUST_FIN_CORP_SFDR(Base):
    __tablename__ = 'EU_SUST_FIN_CORP_SFDR'
    __table_args__ = {"schema": "ESG"}
    
    PUBLICATION_DATE = Column(DateTime, primary_key=True)
    ISSUERID = Column(String(80), primary_key=True)
    FISCAL_YEAR = Column(Integer)
    CARBON_EMISSIONS_SCOPE_1 = Column(Integer)
    CARBON_EMISSIONS_SCOPE_2 = Column(Integer)
    CARBON_EMISSIONS_YEAR = Column(Integer)
    CARBON_EMISSIONS_SCOPE_3_TOTAL = Column(Integer)
    CARBON_EMISSIONS_SCOPE_3_ESTIMATES_YEAR = Column(Integer)
    LABOR_COMPLIANCE_BROAD = Column(String(80))
    COAL_CON_GWH = Column(Integer)
    LIGNITE_CON_GWH = Column(Integer)
    NGAS_CON_GWH = Column(Integer)
    OG_CONSUMP_GWH = Column(Integer)
    NUCLEAR_CON_GWH = Column(Integer)
    FFUEL_CON_GWH = Column(Integer)
    OTHER_NRENEW_CON_GWH = Column(Integer)
    HIGH_EXTREME_WTR_STRESS = Column(String(80))
    NONRECYL_WASTE = Column(Integer)
    OPS_IUCN_NSPECIES = Column(String(80))
    DEFOREST_POL = Column(String(80))
    CARBON_EMISSIONS_REDUCT_INITIATIVES = Column(String(80))
    TRIR = Column(Integer)
    WORKPLACE_ACC_PREV_POL = Column(String(80))
    WHISTLEBLOWER_PROTECT_POLICY = Column(String(80))
    HUMAN_RGTS_POL = Column(String(80))
    HUMAN_RGTS_DD = Column(String(80))
    HUM_TRAFK_POL = Column(String(80))
    OPS_SRISK_CHILD_LABOR = Column(String(80))
    OPS_SRISK_FORCED_LABOR = Column(String(80))
    CORR_BRIB_POLICY_UN = Column(String(80))
    BREACHES_CORRBRIB = Column(String(80))
    CORR_BRIB_CONVICTIONS = Column(Integer)
    CORR_BRIB_FINES = Column(Integer)
    GENDER_PAY_GAP_RATIO = Column(Integer)
    FM_BOARD_RATIO = Column(Integer)
    ACTIVE_FF_SECTOR_EXPOSURE = Column(String(80))
    TOTL_ERGY_CONSUMP_GWH = Column(Integer)
    TOTL_ERGY_CONSUMP_NONRENEW_GWH = Column(Integer)
    TOTL_ERGY_CONSUMP_RENEW_GWH = Column(Integer)
    TOTL_ENRGY_CONSUMP_YEAR = Column(Integer)
    OPS_PROT_BIODIV_AREAS = Column(String(80))
    WATER_EM_EFF_METRIC_TONS = Column(Integer)
    HAZARD_WASTE_METRIC_TON = Column(Integer)
    LABOR_DDIL_POL_ILO = Column(String(80))
    CONTRO_WEAP_CBLMBW_ANYTIE = Column(String(80))
    ENERGY_CONSUMP_INTEN_USD = Column(Integer)
    CONTR_HUMAN_RIGHTS_N_SEVERE = Column(Integer)
    CEO_EMP_PAY_RATIO_RECENT = Column(Integer)
    GOVERNMENT_RAW_GINI = Column(Integer)
    GOVERNMENT_RAW_PRESS_FREED = Column(Integer)
    GOVERNMENT_RAW_CORR_PERC_INDEX = Column(Integer)
    GOVERNMENT_STABILITY_PEACE_SCORE = Column(Integer)
    GOVERNMENT_RAW_RULE_OF_LAW = Column(Integer)
    OVERALL_FLAG = Column(String(80))
    CONTR_DISCRIMINATION_DIV_N_SEVERE = Column(Integer)
    MECH_UN_GLOBAL_COMPACT = Column(String(80))
    EVIC_EUR = Column(Integer)
    EVIC_USD_RECENT = Column(Integer)
    EVIC_USD_YEAR = Column(Integer)
    SALES_EUR = Column(Integer)
    SALES_USD_RECENT = Column(Integer)
    SALES_USD_YEAR = Column(Integer)
    ENERGY_CONSUMP_INTEN_EUR = Column(Integer)
    PCT_NONRENEW_CONSUMP_PROD = Column(Integer)
    OPS_PROT_BIODIV_CONTROVS = Column(String(80))
    NON_COOP_TAX_JURIS = Column(String(80))
    ENVIRONMENT_LAND_FLAG = Column(String(80))
    GOVERNMENT_EU_SANCTIONS = Column(String(80))
    TRIR_YEAR = Column(Integer)
    GENDER_PAY_GAP_YEAR = Column(Integer)
    FM_BOARD_RATIO_YEAR = Column(DateTime)
    ENERGY_CONSUMP_INTEN_EUR_YEAR = Column(Integer)
    HAZARD_WASTE_METRIC_TON_YEAR = Column(Integer)
    NONRECYL_WASTE_YEAR = Column(Integer)
    TOTL_ERGY_CONSUMP_NONRENEW_GWH_YEAR = Column(Integer)
    WATER_EM_EFF_METRIC_TONS_YEAR = Column(Integer)
    CTRY_GHG_INTEN_GDP_EUR = Column(Integer)
    GOVERNMENT_FUNDAMENTAL_RIGHTS = Column(Integer)
    CARBON_EMISSIONS_EVIC_EUR_SCOPE123_INTEN = Column(Integer)
    CARBON_EMISSIONS_SCOPE123 = Column(Integer)
    CARBON_EMISSIONS_SALES_EUR_SCOPE123_INTEN = Column(Integer)
    CARBON_REDUCT_INITIATIVES_PA = Column(String(80))
    LAST_MODIFIED_ON = Column(DateTime)


class CLIMATE_ISSUER_MASTER(Base):
    __tablename__ = 'CLIMATE_ISSUER_MASTER'
    __table_args__ = {"schema": "ESG"}
    
    ISSUER_NAME = Column(String(80), primary_key=True)
    ISSUERID = Column(String(80), primary_key=True)
    ISSUER_LEI = Column(String(80))
    COUNTRY_OF_CLASSIFICATION = Column(String(80))
    ISSUER_CNTRY_DOMICILE = Column(String(80))
    GICS_SUB_IND = Column(String(80))
    GICS_SUB_IND_CODE = Column(String(80))
    GICS_IND = Column(String(80))
    GICS_IND_CODE = Column(String(80))
    GICS_SECTOR = Column(String(80))
    GICS_SECTOR_CODE = Column(String(80))
    GICS_IND_GRP = Column(String(80))
    GICS_IND_GRP_CODE = Column(String(80))
    PARENT_ISSUERID = Column(String(80))
    PARENT_ISSUERNAME = Column(String(80))
    PARENT_ULTIMATE_ISSUERID = Column(String(80))
    PARENT_ULTIMATE_ISSUERNAME = Column(String(80))
    ISSUER_TYPE = Column(String(80))
    PUBLICATION_DATE = Column(DateTime)
    AS_OF_DATE = Column(DateTime)
    LAST_MODIFIED_ON = Column(DateTime)


class CLIMATE_INSTRUMENT_MASTER(Base):
    __tablename__ = 'CLIMATE_INSTRUMENT_MASTER'
    __table_args__ = {"schema": "ESG"}
    
    ISSUER_NAME = Column(String(80), primary_key=True)
    ISSUERID = Column(String(80), primary_key=True)
    TICKER = Column(String(80))
    ISIN = Column(String(80))
    CUSIP = Column(String(80))
    SEDOL = Column(String(80))
    CINS = Column(String(80))
    ASSET_TYPE = Column(String(80))
    MARKET_STATUS = Column(String(80))
    SECURITY_COUNTRY = Column(String(80))
    EXCHANGE = Column(String(80))
    FIGI = Column(String(80))
    SHARECLASSFIGI = Column(String(80))
    COMPOSITEFIGI = Column(String(80))
    LOANX_ID = Column(String(80))
    LOAN_TYPE = Column(String(80))
    LOAN_BORROWER_NAME = Column(String(80))
    LOAN_STATED_XIBOR_SPREAD = Column(String(80))
    PUBLICATION_DATE = Column(DateTime)
    LOAN_MATURITY_DATE = Column(String(80))
    AS_OF_DATE = Column(DateTime)
    LAST_MODIFIED_ON = Column(DateTime)
